window.fc = window.fc || {};
window.fc.ssjjh5 = window.fc.ssjjh5 || {};

(function (exports, Laya) {
    'use strict';

    window.wx = window.h5api;

    class Channel {

        static init() {

            if (typeof h5api == "undefined") {
                console.warn("[adapter]Channel.login:", "tt is undefine");
                return false;
            }


            // if (Laya.MiniAdpter && Laya.MiniAdpter.getUrlEncode) {
            //     Laya.MiniAdpter.getUrlEncode = function (url, type) {
            //         if (url.indexOf(".fnt") != -1 || url.indexOf(".json") != -1) {
            //             return "utf8";
            //         }
            //         else if (type == "arraybuffer") {
            //             return "";
            //         }
            //         return "ascii";
            //     };
            // }
            console.log("ttChannel.init");
            return true;
        }

        static initAdService(info) {

            // if (!info) {
            //     console.warn("[adapter]Channel.init:", "info is invalid");
            //     return true;
            // }

            this.initVideoAd(info.videoAdUnitId);
            // if (info.videoAdUnitId) {
            // }

            this.initBannerAd(info.bannerAdUnitId, info.bannerAdScale);
            // if (info.bannerAdUnitId) {
            // }

            this.initInsertAd(info.insertAdUnitId);
            // if (info.insertAdUnitId) {
            // }

            return true;
        }

        static initBannerAd(bannerAdUnitId, bannerAdScale) {
            this.bannerAdUnitId = bannerAdUnitId;
            this.bannerAdScale = bannerAdScale;
            return true;
        }

        static initInsertAd(insertAdUnitId) {
            this.insertAdUnitId = insertAdUnitId;

            if (typeof h5api == "undefined") {
                console.warn("[adapter]Channel.loadInsertAd:", "qq is undefine");
                return false;
            }
            if (typeof h5api.createInterstitialAd != 'function') {
                console.warn("[adapter]Channel.initInsertAd:", "interstitialAd is unsupported");
                return;
            }

            this.insertAd = h5api.createInterstitialAd();
            if (this.insertAd == null) {
                console.warn("[adapter]Channel.loadInsertAd:", "insertAd is undefine");
                return false;
            }
            var self = this;
            this.insertAd.onLoad(function () {
                self.insertAdReady = true;
                console.log('插屏初始化成功');
                // if (self.insertAdLoadedHandler) {
                //     self.insertAdLoadedHandler.run();
                // }
                // self.insertAdLoadedHandler = null;
            });
            this.insertAd.onError(function (err) {
                console.log(err);
                if (self.insertAdErrorHandler) {
                    self.insertAdErrorHandler.runWith(err);
                }
                self.insertAd = null;
            });
            this.insertAd.onClose(function () {
                self.insertAdReady = false;
                if (self.insertAdCloseHandler) {
                    self.insertAdCloseHandler.run();
                }
                self.insertAdLoadedHandler = null;
                self.insertAdErrorHandler = null;
                self.insertAdCloseHandler = null;
                self.insertAd.load();
            });

            this.insertAd.load();

            return true;
        }

        static initVideoAd(videoAdUnit) {
            console.log("initVideoAd 初始化uc视频！");
            this.rewardedVideoAd = null;
            if (typeof h5api == "undefined") {
                console.warn("[adapter]Channel.initVideoAd:", "tt is undefine");
                return false;
            }
        
   
            return true;
        }

        static initGameBox(gameBoxUnitId) {
            console.log("initGameBox:", gameBoxUnitId);
            return true;
        }

        static isGameBoxValid() {
            return true;
        }

        static showGameBox(success, fail, close) {
            console.log("showGameBox");
            if (typeof h5api == "undefined") {
                console.warn("[adapter]Channel.showGameBox:", "h5api is undefine");
                return false;
            }
            window.h5api.showRecommend();
            

            return true;
        }

        static login(successHandler, failedHandler) {

            if (typeof h5api == "undefined") {
                console.warn("[adapter]Channel.login:", "tt is undefine");
                return false;
            }

            this.loginSuccess = successHandler;
            this.loginFailed = failedHandler;
            this.loginNum++;
            var self = this;

            h5api.login(function (data) {
                /* data = {
                      uId: 1234567, // 用户编号
                      userName: '昵称', // 用户昵称
                  } */
                  if(data){
                      console.log("登陆成功"+JSON.stringify(data));
                  }
              });
            return true;
        }



        static showModal(title, content, confirmTxt, cancelTxt, success, failed, complete) {

            if (typeof h5api == "undefined") {
                console.warn("[adapter]Channel.showModal:", "tt is undefine");
                return false;
            }
            if(success){
                success && success.run();
            }else if(complete){ 
                complete && complete.run();
            }

            return true;
        }

        static createBannerAd(errorHandler) {
            if (typeof h5api == "undefined") {
                console.warn("[adapter]Channel.createBannerAd:", "tt is undefine");
                return false;
            }

            if (typeof h5api.createBannerAd != 'function') {
                console.warn("[adapter]Channel.createBannerAd:", "banner is unsupported");
                return false;
            }

            return true;
        }

        static showBannerAd() {
            console.log("showBannerAd");
            return true;
        }

        static hideBannerAd() {
            console.log("hideBannerAd");
    
            return true;
        }

        static destroyBannerAd() {
            console.log("destroyBannerAd");
 
            return true;
        }

        static isBannerAdValid() {
            return false;
        }

        static playVideo(completedHandler, interruptHandler, errorHandler) {
            if (typeof h5api == "undefined") {
                console.warn("[adapter]Channel.playVideo:", "tt is undefine");
                return false;
            }

            this.videoErrorHandler = errorHandler;
            this.videoCompletedHandler = completedHandler;
            this.videoInterruptHandler = interruptHandler;
          

            var self = this;
            h5api.playAd(function callback(obj) {
                console.log("代码:" + obj.code + ",消息:" + obj.message);
                if (obj.code === 10000) {
                  console.log("开始播放");
                } else if (obj.code === 10001) {
                  console.log("播放结束");
                  self.videoCompletedHandler.run();
                } else {
                    console.log("广告异常");
                    self.videoInterruptHandler.run();
                }
              });

            return true;
        }

        static isVideoEnable() {
            return true;
        }

        static loadInsertAd(loadedHandler, errorHandler) {
            if (typeof h5api == "undefined") {
                console.warn("[adapter]Channel.loadInsertAd:", "qq is undefine");
                return false;
            }
     
    
            this.insertAdLoadedHandler = loadedHandler;
            this.insertAdErrorHandler = errorHandler;
           

            return false;
        }
        
        static showInsertAd(closeHandler, errorHandler) {
            if (typeof h5api == "undefined") {
                console.warn("[adapter]Channel.showInsertAd:", "qq is undefine");
                return false;
            }
            this.insertAdCloseHandler = closeHandler;
            this.insertAdErrorHandler = errorHandler;

            var self = this;
            // h5api.playAd(function callback(obj) {
            //     console.log("代码:" + obj.code + ",消息:" + obj.message);
            //     if (obj.code === 10000) {
            //       console.log("开始播放");
            //     } else if (obj.code === 10001) {
            //       console.log("播放结束");
            //     } else {
            //         console.log("广告异常");
            //     }
            //   });
            return false;
        }

        static isInsertAdEnable() {
            return true;
        }

        
        static shareAppMessage(data, success, failed) {
            if (typeof h5api == "undefined") {
                console.warn("[adapter]Channel.openShare:", "uc is undefine");
                return false;
            }

            h5api.share();
            return true;
        }

        

    }
    Channel.loginNum = 0;
    Channel.rewardedVideoAd = null;
    Channel.videoCompletedHandler = null;
    Channel.videoInterruptHandler = null;
    Channel.videoErrorHandler = null;
    Channel.insertAd = null;
    Channel.insertAdUnitId = null;
    Channel.insertAdReady = false;
    Channel.insertAdAutoPlay = false;
    Channel.insertAdErrorHandler = null;
    Channel.insertAdCloseHandler = null;
    Channel.insertAdLoadedHandler = null;
    Channel.bannerAd = null;
    Channel.bannerAdUnitId = null;
    Channel.bannerAdScale = 1;
    Channel.bannerAdIsReady = false;
    Channel.bannerAdVisible = false;
    Channel.bannerErrorHandler = null;




    var validNetConnectType = ["2g", "3g", "4g", "5g", "wifi"];

    class Device {

        static get statusBarHeight() {
            if (this.sDeviceInfo && this.sDeviceInfo.model) {
                let model = this.sDeviceInfo.model.toLowerCase().replace(/\s*/g, "");
                if (model.indexOf('iphonex') != -1) {
                    return 44;
                }
            }
            return this.sDeviceInfo ? this.sDeviceInfo.statusBarHeight : 0;
        }

        static get screenWidth() {
            return this.sDeviceInfo ? this.sDeviceInfo.screenWidth : 1;
        }

        static get screenHeight() {
            return this.sDeviceInfo ? this.sDeviceInfo.screenHeight : 1;
        }

        static init(onShowHandler, onHideHandler) {
            if (typeof h5api == "undefined") {
                console.warn("[adapter]Device.init:", "tt is undefine");
                return false;
            }
            if (typeof h5api.getSystemInfoSync != 'function') {
                console.warn("[adapter]Device.init:", "getSystemInfoSync is undefine");
                return false;
            }

            this.sDeviceInfo = h5api.getSystemInfoSync();
            console.log(this.sDeviceInfo);
            console.log("ttDeviceAdapter.init");
   
            return true;
        }

        static vibrateShort() {
            // if (typeof uc == "undefined") {
            //     console.warn("[adapter]Device.vibrateShort:", "tt is undefine");
            //     return false;
            // }
            // uc.vibrateShort({
            //     fail: function () {
            //         console.log("vibrateShort failed");
            //     },
            // });
            return true;
        }

        static vibrateLong() {
            // if (typeof uc == "undefined") {
            //     console.warn("[adapter]Device.vibrateLong:", "tt is undefine");
            //     return false;
            // }
            // uc.vibrateLong({
            //     fail: function () {
            //         console.log("vibrateShort failed");
            //     },
            // });
            return true;
        }

        static isNetValid() {
            return true;
        }
    }
    Device.sAudioArr = [];
    Device.sSoundInfo = {};
    Device.sContinue = false;
    Device.sDeviceInfo = null;
    Device.sNetworkType = "";
    Device.sIsNetConnected = false;

    exports.Channel = Channel;
    exports.Device = Device;

}(window.fc.ssjjh5, Laya))

window.fc.adapter = window.fc.ssjjh5;